Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkImplicitModeller Class Reference

`#include <vtkImplicitModeller.h>`

Inheritance diagram for vtkImplicitModeller:

[legend]
Collaboration diagram for vtkImplicitModeller:

[legend]
List of all members.

## Detailed Description

compute distance from input geometry on structured point dataset

Date:
  2002/10/28 19:01:41

Revision:
  1.58

vtkImplicitModeller is a filter that computes the distance from the input geometry to the points of an output structured point set. This distance function can then be "contoured" to generate new, offset surfaces from the original geometry. An important feature of this object is "capping". If capping is turned on, after the implicit model is created, the values on the boundary of the structured points dataset are set to the cap value. This is used to force closure of the resulting contoured surface. Note, however, that large cap values can generate weird surface normals in those cells adjacent to the boundary of the dataset. Using smaller cap value will reduce this effect.

Another important ivar is MaximumDistance. This controls how far into the volume the distance function is computed from the input geometry. Small values give significant increases in performance. However, there can strange sampling effects at the extreme range of the MaximumDistance.

In order to properly execute and sample the input data, a rectangular region in space must be defined (this is the ivar ModelBounds). If not explicitly defined, the model bounds will be computed. Note that to avoid boundary effects, it is possible to adjust the model bounds (i.e., using the AdjustBounds and AdjustDistance ivars) to strictly contain the sampled data.

This filter has one other unusual capability: it is possible to append data in a sequence of operations to generate a single output. This is useful when you have multiple datasets and want to create a conglomeration of all the data. However, the user must be careful to either specify the ModelBounds or specify the first item such that its bounds completely contain all other items. This is because the rectangular region of the output can not be changed after the 1st Append.

The ProcessMode ivar controls the method used within the Append function (where the actual work is done regardless if the Append function is explicitly called) to compute the implicit model. If set to work in voxel mode, each voxel is visited once. If set to cell mode, each cell is visited once. Tests have shown once per voxel to be faster when there are a lot of cells (at least a thousand?); relative performance improvement increases with addition cells. Primitives should not be stripped for best performance of the voxel mode. Also, if explicitly using the Append feature many times, the cell mode will probably be better because each voxel will be visited each Append. Append the data before input if possible when using the voxel mode.

Further performance improvement is now possible using the PerVoxel process mode on multi-processor machines (the mode is now multithreaded). Each thread processes a different "slab" of the output. Also, if the input is vtkPolyData, it is appropriately clipped for each thread; that is, each thread only considers the input which could affect its slab of the output.

See also:
  vtkSampleFunction vtkContourFilter

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (37%)
  - Blue, Rusty (34%)
  - Lorensen, Bill (13%)
  - Martin, Ken (6%)

CVS logs (CVSweb):
  - .`h` (`/Hybrid/vtkImplicitModeller.h)`
  - .`cxx` (`/Hybrid/vtkImplicitModeller.cxx)`

Examples:
  vtkImplicitModeller (Examples)

Tests:
  vtkImplicitModeller (Tests)

Definition at line 106 of file vtkImplicitModeller.h.

## Public Types
typedef vtkDataSetToImageFilter | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
float | ComputeModelBounds (vtkDataSet *input=NULL)
void | StartAppend ()
void | Append (vtkDataSet *input)
void | EndAppend ()
virtual void | UpdateData (vtkDataObject *output)
virtual int * | GetSampleDimensions ()
virtual void | GetSampleDimensions (int data[3])
void | SetSampleDimensions (int i, int j, int k)
void | SetSampleDimensions (int dim[3])
virtual void | SetMaximumDistance (float)
virtual float | GetMaximumDistance ()
virtual void | SetModelBounds (float, float, float, float, float, float)
virtual void | SetModelBounds (float[6])
virtual float * | GetModelBounds ()
virtual void | GetModelBounds (float data[6])
virtual void | SetAdjustBounds (int)
virtual int | GetAdjustBounds ()
virtual void | AdjustBoundsOn ()
virtual void | AdjustBoundsOff ()
virtual void | SetAdjustDistance (float)
virtual float | GetAdjustDistance ()
virtual void | SetCapping (int)
virtual int | GetCapping ()
virtual void | CappingOn ()
virtual void | CappingOff ()
virtual void | SetCapValue (float)
virtual float | GetCapValue ()
virtual void | SetProcessMode (int)
virtual int | GetProcessMode ()
void | SetProcessModeToPerVoxel ()
void | SetProcessModeToPerCell ()
const char * | GetProcessModeAsString (void)
virtual void | SetLocatorMaxLevel (int)
virtual int | GetLocatorMaxLevel ()
virtual void | SetNumberOfThreads (int)
virtual int | GetNumberOfThreads ()
## Static Public Methods
int | IsTypeOf (const char *type)
vtkImplicitModeller * | SafeDownCast (vtkObject *o)
vtkImplicitModeller * | New ()
## Protected Methods
| vtkImplicitModeller ()
| ~vtkImplicitModeller ()
void | ExecuteData (vtkDataObject *)
void | ExecuteInformation ()
void | Cap (vtkDataArray *s)
## Protected Attributes
vtkMultiThreader * | Threader
int | NumberOfThreads
int | SampleDimensions [3]
float | MaximumDistance
float | ModelBounds [6]
int | Capping
float | CapValue
int | DataAppended
int | AdjustBounds
float | AdjustDistance
int | ProcessMode
int | LocatorMaxLevel
int | BoundsComputed
float | InternalMaxDistance

## Member Typedef Documentation

typedef vtkDataSetToImageFilter vtkImplicitModeller::Superclass

| Reimplemented from vtkDataSetToImageFilter. Definition at line 109 of file vtkImplicitModeller.h.

## Constructor & Destructor Documentation

vtkImplicitModeller::vtkImplicitModeller | ( |  | ) | `[protected]`

vtkImplicitModeller::~vtkImplicitModeller | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkImplicitModeller::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkDataSetToImageFilter.

int vtkImplicitModeller::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkDataSetToImageFilter.

virtual int vtkImplicitModeller::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkDataSetToImageFilter.

vtkImplicitModeller* vtkImplicitModeller::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkDataSetToImageFilter.

void vtkImplicitModeller::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkDataSetToImageFilter.

vtkImplicitModeller* vtkImplicitModeller::New | ( |  | ) | `[static]`

| Construct with sample dimensions=(50,50,50), and so that model bounds are automatically computed from the input. Capping is turned on with CapValue equal to a large positive number. Reimplemented from vtkObject.

float vtkImplicitModeller::ComputeModelBounds | ( | vtkDataSet * | input = NULL | ) |

| Compute ModelBounds from input geometry. If input is not specified, the input of the filter will be used.

virtual int* vtkImplicitModeller::GetSampleDimensions | ( |  | ) | `[virtual]`

| Set/Get the i-j-k dimensions on which to sample distance function.

virtual void vtkImplicitModeller::GetSampleDimensions | ( | int | data[3] | ) | `[virtual]`

| Set/Get the i-j-k dimensions on which to sample distance function.

void vtkImplicitModeller::SetSampleDimensions | ( | int | i,
|  | int | j,
|  | int | k
| ) |

| Set/Get the i-j-k dimensions on which to sample distance function.

void vtkImplicitModeller::SetSampleDimensions | ( | int | dim[3] | ) |

| Set/Get the i-j-k dimensions on which to sample distance function.

virtual void vtkImplicitModeller::SetMaximumDistance | ( | float |  | ) | `[virtual]`

| Set / get the distance away from surface of input geometry to sample. Smaller values make large increases in performance.

virtual float vtkImplicitModeller::GetMaximumDistance | ( |  | ) | `[virtual]`

| Set / get the distance away from surface of input geometry to sample. Smaller values make large increases in performance.

virtual void vtkImplicitModeller::SetModelBounds | ( | float | ,
|  | float | ,
|  | float | ,
|  | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set / get the region in space in which to perform the sampling. If not specified, it will be computed automatically.

virtual void vtkImplicitModeller::SetModelBounds | ( | float | [6] | ) | `[virtual]`

| Set / get the region in space in which to perform the sampling. If not specified, it will be computed automatically.

virtual float* vtkImplicitModeller::GetModelBounds | ( |  | ) | `[virtual]`

| Set / get the region in space in which to perform the sampling. If not specified, it will be computed automatically.

virtual void vtkImplicitModeller::GetModelBounds | ( | float | data[6] | ) | `[virtual]`

| Set / get the region in space in which to perform the sampling. If not specified, it will be computed automatically.

virtual void vtkImplicitModeller::SetAdjustBounds | ( | int |  | ) | `[virtual]`

| Control how the model bounds are computed. If the ivar AdjustBounds is set, then the bounds specified (or computed automatically) is modified by the fraction given by AdjustDistance. This means that the model bounds is expanded in each of the x-y-z directions.

virtual int vtkImplicitModeller::GetAdjustBounds | ( |  | ) | `[virtual]`

| Control how the model bounds are computed. If the ivar AdjustBounds is set, then the bounds specified (or computed automatically) is modified by the fraction given by AdjustDistance. This means that the model bounds is expanded in each of the x-y-z directions.

virtual void vtkImplicitModeller::AdjustBoundsOn | ( |  | ) | `[virtual]`

| Control how the model bounds are computed. If the ivar AdjustBounds is set, then the bounds specified (or computed automatically) is modified by the fraction given by AdjustDistance. This means that the model bounds is expanded in each of the x-y-z directions.

virtual void vtkImplicitModeller::AdjustBoundsOff | ( |  | ) | `[virtual]`

| Control how the model bounds are computed. If the ivar AdjustBounds is set, then the bounds specified (or computed automatically) is modified by the fraction given by AdjustDistance. This means that the model bounds is expanded in each of the x-y-z directions.

virtual void vtkImplicitModeller::SetAdjustDistance | ( | float |  | ) | `[virtual]`

| Specify the amount to grow the model bounds (if the ivar AdjustBounds is set). The value is a fraction of the maximum length of the sides of the box specified by the model bounds.

virtual float vtkImplicitModeller::GetAdjustDistance | ( |  | ) | `[virtual]`

| Specify the amount to grow the model bounds (if the ivar AdjustBounds is set). The value is a fraction of the maximum length of the sides of the box specified by the model bounds.

virtual void vtkImplicitModeller::SetCapping | ( | int |  | ) | `[virtual]`

| The outer boundary of the structured point set can be assigned a particular value. This can be used to close or "cap" all surfaces.

virtual int vtkImplicitModeller::GetCapping | ( |  | ) | `[virtual]`

| The outer boundary of the structured point set can be assigned a particular value. This can be used to close or "cap" all surfaces.

virtual void vtkImplicitModeller::CappingOn | ( |  | ) | `[virtual]`

| The outer boundary of the structured point set can be assigned a particular value. This can be used to close or "cap" all surfaces.

virtual void vtkImplicitModeller::CappingOff | ( |  | ) | `[virtual]`

| The outer boundary of the structured point set can be assigned a particular value. This can be used to close or "cap" all surfaces.

virtual void vtkImplicitModeller::SetCapValue | ( | float |  | ) | `[virtual]`

| Specify the capping value to use. The CapValue is also used as an initial distance value at each point in the dataset.

virtual float vtkImplicitModeller::GetCapValue | ( |  | ) | `[virtual]`

| Specify the capping value to use. The CapValue is also used as an initial distance value at each point in the dataset.

virtual void vtkImplicitModeller::SetProcessMode | ( | int |  | ) | `[virtual]`

| Specify whether to visit each cell once per append or each voxel once per append. Some tests have shown once per voxel to be faster when there are a lot of cells (at least a thousand?); relative performance improvement increases with addition cells. Primitives should not be stripped for best performance of the voxel mode.

virtual int vtkImplicitModeller::GetProcessMode | ( |  | ) | `[virtual]`

| Specify whether to visit each cell once per append or each voxel once per append. Some tests have shown once per voxel to be faster when there are a lot of cells (at least a thousand?); relative performance improvement increases with addition cells. Primitives should not be stripped for best performance of the voxel mode.

void vtkImplicitModeller::SetProcessModeToPerVoxel | ( |  | ) | `[inline]`

| Specify whether to visit each cell once per append or each voxel once per append. Some tests have shown once per voxel to be faster when there are a lot of cells (at least a thousand?); relative performance improvement increases with addition cells. Primitives should not be stripped for best performance of the voxel mode. Definition at line 183 of file vtkImplicitModeller.h. References VTK_VOXEL_MODE.

void vtkImplicitModeller::SetProcessModeToPerCell | ( |  | ) | `[inline]`

| Specify whether to visit each cell once per append or each voxel once per append. Some tests have shown once per voxel to be faster when there are a lot of cells (at least a thousand?); relative performance improvement increases with addition cells. Primitives should not be stripped for best performance of the voxel mode. Definition at line 184 of file vtkImplicitModeller.h. References VTK_CELL_MODE.

const char* vtkImplicitModeller::GetProcessModeAsString | ( | void |  | ) |

| Specify whether to visit each cell once per append or each voxel once per append. Some tests have shown once per voxel to be faster when there are a lot of cells (at least a thousand?); relative performance improvement increases with addition cells. Primitives should not be stripped for best performance of the voxel mode.

virtual void vtkImplicitModeller::SetLocatorMaxLevel | ( | int |  | ) | `[virtual]`

| Specify the level of the locator to use when using the per voxel process mode.

virtual int vtkImplicitModeller::GetLocatorMaxLevel | ( |  | ) | `[virtual]`

| Specify the level of the locator to use when using the per voxel process mode.

virtual void vtkImplicitModeller::SetNumberOfThreads | ( | int |  | ) | `[virtual]`

| Set / Get the number of threads used during Per-Voxel processing mode

virtual int vtkImplicitModeller::GetNumberOfThreads | ( |  | ) | `[virtual]`

| Set / Get the number of threads used during Per-Voxel processing mode

void vtkImplicitModeller::StartAppend | ( |  | ) |

| Initialize the filter for appending data. You must invoke the StartAppend() method before doing successive Appends(). It's also a good idea to manually specify the model bounds; otherwise the input bounds for the data will be used.

void vtkImplicitModeller::Append | ( | vtkDataSet * | input | ) |

| Append a data set to the existing output. To use this function, you'll have to invoke the StartAppend() method before doing successive appends. It's also a good idea to specify the model bounds; otherwise the input model bounds is used. When you've finished appending, use the EndAppend() method.

void vtkImplicitModeller::EndAppend | ( |  | ) |

| Method completes the append process.

virtual void vtkImplicitModeller::UpdateData | ( | vtkDataObject * | output | ) | `[virtual]`

| Reimplemented from vtkSource.

void vtkImplicitModeller::ExecuteData | ( | vtkDataObject * |  | ) | `[protected]`

void vtkImplicitModeller::ExecuteInformation | ( |  | ) | `[protected, virtual]`

| Reimplemented from vtkSource.

void vtkImplicitModeller::Cap | ( | vtkDataArray * | s | ) | `[protected]`

## Member Data Documentation

vtkMultiThreader* vtkImplicitModeller::Threader`[protected]`

| Definition at line 228 of file vtkImplicitModeller.h.

int vtkImplicitModeller::NumberOfThreads`[protected]`

| Definition at line 229 of file vtkImplicitModeller.h.

int vtkImplicitModeller::SampleDimensions[3]`[protected]`

| Definition at line 231 of file vtkImplicitModeller.h.

float vtkImplicitModeller::MaximumDistance`[protected]`

| Definition at line 232 of file vtkImplicitModeller.h.

float vtkImplicitModeller::ModelBounds[6]`[protected]`

| Definition at line 233 of file vtkImplicitModeller.h.

int vtkImplicitModeller::Capping`[protected]`

| Definition at line 234 of file vtkImplicitModeller.h.

float vtkImplicitModeller::CapValue`[protected]`

| Definition at line 235 of file vtkImplicitModeller.h.

int vtkImplicitModeller::DataAppended`[protected]`

| Definition at line 236 of file vtkImplicitModeller.h.

int vtkImplicitModeller::AdjustBounds`[protected]`

| Definition at line 237 of file vtkImplicitModeller.h.

float vtkImplicitModeller::AdjustDistance`[protected]`

| Definition at line 238 of file vtkImplicitModeller.h.

int vtkImplicitModeller::ProcessMode`[protected]`

| Definition at line 239 of file vtkImplicitModeller.h.

int vtkImplicitModeller::LocatorMaxLevel`[protected]`

| Definition at line 240 of file vtkImplicitModeller.h.

int vtkImplicitModeller::BoundsComputed`[protected]`

| Definition at line 242 of file vtkImplicitModeller.h.

float vtkImplicitModeller::InternalMaxDistance`[protected]`

| Definition at line 243 of file vtkImplicitModeller.h.

The documentation for this class was generated from the following file:

- Hybrid/vtkImplicitModeller.h